// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: gps.proto

#define INTERNAL_SUPPRESS_PROTOBUF_FIELD_DEPRECATION
#include "gps.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// @@protoc_insertion_point(includes)

namespace {

const ::google::protobuf::Descriptor* GpsInfo_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  GpsInfo_reflection_ = NULL;

}  // namespace


void protobuf_AssignDesc_gps_2eproto() GOOGLE_ATTRIBUTE_COLD;
void protobuf_AssignDesc_gps_2eproto() {
  protobuf_AddDesc_gps_2eproto();
  const ::google::protobuf::FileDescriptor* file =
    ::google::protobuf::DescriptorPool::generated_pool()->FindFileByName(
      "gps.proto");
  GOOGLE_CHECK(file != NULL);
  GpsInfo_descriptor_ = file->message_type(0);
  static const int GpsInfo_offsets_[5] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, lat_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, lon_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, azi_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, speed_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, status_),
  };
  GpsInfo_reflection_ =
    ::google::protobuf::internal::GeneratedMessageReflection::NewGeneratedMessageReflection(
      GpsInfo_descriptor_,
      GpsInfo::default_instance_,
      GpsInfo_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, _has_bits_[0]),
      -1,
      -1,
      sizeof(GpsInfo),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, _internal_metadata_),
      -1);
}

namespace {

GOOGLE_PROTOBUF_DECLARE_ONCE(protobuf_AssignDescriptors_once_);
inline void protobuf_AssignDescriptorsOnce() {
  ::google::protobuf::GoogleOnceInit(&protobuf_AssignDescriptors_once_,
                 &protobuf_AssignDesc_gps_2eproto);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
      GpsInfo_descriptor_, &GpsInfo::default_instance());
}

}  // namespace

void protobuf_ShutdownFile_gps_2eproto() {
  delete GpsInfo::default_instance_;
  delete GpsInfo_reflection_;
}

void protobuf_AddDesc_gps_2eproto() GOOGLE_ATTRIBUTE_COLD;
void protobuf_AddDesc_gps_2eproto() {
  static bool already_here = false;
  if (already_here) return;
  already_here = true;
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
    "\n\tgps.proto\"O\n\007GpsInfo\022\013\n\003lat\030\001 \002(\001\022\013\n\003l"
    "on\030\002 \002(\001\022\013\n\003azi\030\003 \001(\001\022\r\n\005speed\030\004 \001(\001\022\016\n\006"
    "status\030\005 \001(\r", 92);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "gps.proto", &protobuf_RegisterTypes);
  GpsInfo::default_instance_ = new GpsInfo();
  GpsInfo::default_instance_->InitAsDefaultInstance();
  ::google::protobuf::internal::OnShutdown(&protobuf_ShutdownFile_gps_2eproto);
}

// Force AddDescriptors() to be called at static initialization time.
struct StaticDescriptorInitializer_gps_2eproto {
  StaticDescriptorInitializer_gps_2eproto() {
    protobuf_AddDesc_gps_2eproto();
  }
} static_descriptor_initializer_gps_2eproto_;

// ===================================================================

#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int GpsInfo::kLatFieldNumber;
const int GpsInfo::kLonFieldNumber;
const int GpsInfo::kAziFieldNumber;
const int GpsInfo::kSpeedFieldNumber;
const int GpsInfo::kStatusFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

GpsInfo::GpsInfo()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  SharedCtor();
  // @@protoc_insertion_point(constructor:GpsInfo)
}

void GpsInfo::InitAsDefaultInstance() {
}

GpsInfo::GpsInfo(const GpsInfo& from)
  : ::google::protobuf::Message(),
    _internal_metadata_(NULL) {
  SharedCtor();
  MergeFrom(from);
  // @@protoc_insertion_point(copy_constructor:GpsInfo)
}

void GpsInfo::SharedCtor() {
  _cached_size_ = 0;
  lat_ = 0;
  lon_ = 0;
  azi_ = 0;
  speed_ = 0;
  status_ = 0u;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

GpsInfo::~GpsInfo() {
  // @@protoc_insertion_point(destructor:GpsInfo)
  SharedDtor();
}

void GpsInfo::SharedDtor() {
  if (this != default_instance_) {
  }
}

void GpsInfo::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* GpsInfo::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return GpsInfo_descriptor_;
}

const GpsInfo& GpsInfo::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_gps_2eproto();
  return *default_instance_;
}

GpsInfo* GpsInfo::default_instance_ = NULL;

GpsInfo* GpsInfo::New(::google::protobuf::Arena* arena) const {
  GpsInfo* n = new GpsInfo;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void GpsInfo::Clear() {
// @@protoc_insertion_point(message_clear_start:GpsInfo)
#if defined(__clang__)
#define ZR_HELPER_(f) \
  _Pragma("clang diagnostic push") \
  _Pragma("clang diagnostic ignored \"-Winvalid-offsetof\"") \
  __builtin_offsetof(GpsInfo, f) \
  _Pragma("clang diagnostic pop")
#else
#define ZR_HELPER_(f) reinterpret_cast<char*>(\
  &reinterpret_cast<GpsInfo*>(16)->f)
#endif

#define ZR_(first, last) do {\
  ::memset(&first, 0,\
           ZR_HELPER_(last) - ZR_HELPER_(first) + sizeof(last));\
} while (0)

  if (_has_bits_[0 / 32] & 31u) {
    ZR_(lat_, status_);
  }

#undef ZR_HELPER_
#undef ZR_

  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  if (_internal_metadata_.have_unknown_fields()) {
    mutable_unknown_fields()->Clear();
  }
}

bool GpsInfo::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:GpsInfo)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoff(127);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required double lat = 1;
      case 1: {
        if (tag == 9) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &lat_)));
          set_has_lat();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(17)) goto parse_lon;
        break;
      }

      // required double lon = 2;
      case 2: {
        if (tag == 17) {
         parse_lon:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &lon_)));
          set_has_lon();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(25)) goto parse_azi;
        break;
      }

      // optional double azi = 3;
      case 3: {
        if (tag == 25) {
         parse_azi:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &azi_)));
          set_has_azi();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(33)) goto parse_speed;
        break;
      }

      // optional double speed = 4;
      case 4: {
        if (tag == 33) {
         parse_speed:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &speed_)));
          set_has_speed();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(40)) goto parse_status;
        break;
      }

      // optional uint32 status = 5;
      case 5: {
        if (tag == 40) {
         parse_status:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &status_)));
          set_has_status();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectAtEnd()) goto success;
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0 ||
            ::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:GpsInfo)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:GpsInfo)
  return false;
#undef DO_
}

void GpsInfo::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:GpsInfo)
  // required double lat = 1;
  if (has_lat()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(1, this->lat(), output);
  }

  // required double lon = 2;
  if (has_lon()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(2, this->lon(), output);
  }

  // optional double azi = 3;
  if (has_azi()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(3, this->azi(), output);
  }

  // optional double speed = 4;
  if (has_speed()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(4, this->speed(), output);
  }

  // optional uint32 status = 5;
  if (has_status()) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(5, this->status(), output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:GpsInfo)
}

::google::protobuf::uint8* GpsInfo::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  // @@protoc_insertion_point(serialize_to_array_start:GpsInfo)
  // required double lat = 1;
  if (has_lat()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(1, this->lat(), target);
  }

  // required double lon = 2;
  if (has_lon()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(2, this->lon(), target);
  }

  // optional double azi = 3;
  if (has_azi()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(3, this->azi(), target);
  }

  // optional double speed = 4;
  if (has_speed()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(4, this->speed(), target);
  }

  // optional uint32 status = 5;
  if (has_status()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteUInt32ToArray(5, this->status(), target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:GpsInfo)
  return target;
}

int GpsInfo::RequiredFieldsByteSizeFallback() const {
// @@protoc_insertion_point(required_fields_byte_size_fallback_start:GpsInfo)
  int total_size = 0;

  if (has_lat()) {
    // required double lat = 1;
    total_size += 1 + 8;
  }

  if (has_lon()) {
    // required double lon = 2;
    total_size += 1 + 8;
  }

  return total_size;
}
int GpsInfo::ByteSize() const {
// @@protoc_insertion_point(message_byte_size_start:GpsInfo)
  int total_size = 0;

  if (((_has_bits_[0] & 0x00000003) ^ 0x00000003) == 0) {  // All required fields are present.
    // required double lat = 1;
    total_size += 1 + 8;

    // required double lon = 2;
    total_size += 1 + 8;

  } else {
    total_size += RequiredFieldsByteSizeFallback();
  }
  if (_has_bits_[2 / 32] & 28u) {
    // optional double azi = 3;
    if (has_azi()) {
      total_size += 1 + 8;
    }

    // optional double speed = 4;
    if (has_speed()) {
      total_size += 1 + 8;
    }

    // optional uint32 status = 5;
    if (has_status()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::UInt32Size(
          this->status());
    }

  }
  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void GpsInfo::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:GpsInfo)
  if (GOOGLE_PREDICT_FALSE(&from == this)) {
    ::google::protobuf::internal::MergeFromFail(__FILE__, __LINE__);
  }
  const GpsInfo* source = 
      ::google::protobuf::internal::DynamicCastToGenerated<const GpsInfo>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:GpsInfo)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:GpsInfo)
    MergeFrom(*source);
  }
}

void GpsInfo::MergeFrom(const GpsInfo& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:GpsInfo)
  if (GOOGLE_PREDICT_FALSE(&from == this)) {
    ::google::protobuf::internal::MergeFromFail(__FILE__, __LINE__);
  }
  if (from._has_bits_[0 / 32] & (0xffu << (0 % 32))) {
    if (from.has_lat()) {
      set_lat(from.lat());
    }
    if (from.has_lon()) {
      set_lon(from.lon());
    }
    if (from.has_azi()) {
      set_azi(from.azi());
    }
    if (from.has_speed()) {
      set_speed(from.speed());
    }
    if (from.has_status()) {
      set_status(from.status());
    }
  }
  if (from._internal_metadata_.have_unknown_fields()) {
    mutable_unknown_fields()->MergeFrom(from.unknown_fields());
  }
}

void GpsInfo::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:GpsInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void GpsInfo::CopyFrom(const GpsInfo& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:GpsInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool GpsInfo::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000003) != 0x00000003) return false;

  return true;
}

void GpsInfo::Swap(GpsInfo* other) {
  if (other == this) return;
  InternalSwap(other);
}
void GpsInfo::InternalSwap(GpsInfo* other) {
  std::swap(lat_, other->lat_);
  std::swap(lon_, other->lon_);
  std::swap(azi_, other->azi_);
  std::swap(speed_, other->speed_);
  std::swap(status_, other->status_);
  std::swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  std::swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata GpsInfo::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = GpsInfo_descriptor_;
  metadata.reflection = GpsInfo_reflection_;
  return metadata;
}

#if PROTOBUF_INLINE_NOT_IN_HEADERS
// GpsInfo

// required double lat = 1;
bool GpsInfo::has_lat() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
void GpsInfo::set_has_lat() {
  _has_bits_[0] |= 0x00000001u;
}
void GpsInfo::clear_has_lat() {
  _has_bits_[0] &= ~0x00000001u;
}
void GpsInfo::clear_lat() {
  lat_ = 0;
  clear_has_lat();
}
 double GpsInfo::lat() const {
  // @@protoc_insertion_point(field_get:GpsInfo.lat)
  return lat_;
}
 void GpsInfo::set_lat(double value) {
  set_has_lat();
  lat_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.lat)
}

// required double lon = 2;
bool GpsInfo::has_lon() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
void GpsInfo::set_has_lon() {
  _has_bits_[0] |= 0x00000002u;
}
void GpsInfo::clear_has_lon() {
  _has_bits_[0] &= ~0x00000002u;
}
void GpsInfo::clear_lon() {
  lon_ = 0;
  clear_has_lon();
}
 double GpsInfo::lon() const {
  // @@protoc_insertion_point(field_get:GpsInfo.lon)
  return lon_;
}
 void GpsInfo::set_lon(double value) {
  set_has_lon();
  lon_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.lon)
}

// optional double azi = 3;
bool GpsInfo::has_azi() const {
  return (_has_bits_[0] & 0x00000004u) != 0;
}
void GpsInfo::set_has_azi() {
  _has_bits_[0] |= 0x00000004u;
}
void GpsInfo::clear_has_azi() {
  _has_bits_[0] &= ~0x00000004u;
}
void GpsInfo::clear_azi() {
  azi_ = 0;
  clear_has_azi();
}
 double GpsInfo::azi() const {
  // @@protoc_insertion_point(field_get:GpsInfo.azi)
  return azi_;
}
 void GpsInfo::set_azi(double value) {
  set_has_azi();
  azi_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.azi)
}

// optional double speed = 4;
bool GpsInfo::has_speed() const {
  return (_has_bits_[0] & 0x00000008u) != 0;
}
void GpsInfo::set_has_speed() {
  _has_bits_[0] |= 0x00000008u;
}
void GpsInfo::clear_has_speed() {
  _has_bits_[0] &= ~0x00000008u;
}
void GpsInfo::clear_speed() {
  speed_ = 0;
  clear_has_speed();
}
 double GpsInfo::speed() const {
  // @@protoc_insertion_point(field_get:GpsInfo.speed)
  return speed_;
}
 void GpsInfo::set_speed(double value) {
  set_has_speed();
  speed_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.speed)
}

// optional uint32 status = 5;
bool GpsInfo::has_status() const {
  return (_has_bits_[0] & 0x00000010u) != 0;
}
void GpsInfo::set_has_status() {
  _has_bits_[0] |= 0x00000010u;
}
void GpsInfo::clear_has_status() {
  _has_bits_[0] &= ~0x00000010u;
}
void GpsInfo::clear_status() {
  status_ = 0u;
  clear_has_status();
}
 ::google::protobuf::uint32 GpsInfo::status() const {
  // @@protoc_insertion_point(field_get:GpsInfo.status)
  return status_;
}
 void GpsInfo::set_status(::google::protobuf::uint32 value) {
  set_has_status();
  status_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.status)
}

#endif  // PROTOBUF_INLINE_NOT_IN_HEADERS

// @@protoc_insertion_point(namespace_scope)

// @@protoc_insertion_point(global_scope)
